// ---------------------------------------------------
// Projet : Test
// Commentaires : Envoi de données à un site de test
// et exécution des commandes associées à deux
// boutons présents sur la page web
// en réponse à ses requêtes (architecture REST)
// Valeur 1 : lecture de l'entrée analogique 0
// Valeur 2 : calculée
// Valeur 3 : constante
// Matériel : Carte Uno Wifi
// Version: 1
// Date: 7/5/2017
// Fichier : testUnoWifi.ino
// ---------------------------------------------------
// Bibliothèques
#include <Wire.h>
#include <UnoWiFiDevEd.h>
// ---------------------------------------------------
// Variable globale
int val = 0;
int val1 = 100;
int val2 = 50;
int val3 = 200;
// ---------------------------------------------------
void setup() {
  Wifi.begin();
}
// ---------------------------------------------------
void loop() {
  while (Wifi.available()) {
    process(Wifi);
  }
  delay(50);
}
// ---------------------------------------------------
void process(WifiData client) {
  // read the command
  String command = client.readStringUntil('/');

  // is "grandeur" command?
  if (command == "analog") {
    analogCommand(client);
  }
  // is "digital" command?
  if (command == "digital") {
    digitalCommand(client);
  }
}
// ---------------------------------------------------
int CalculVal(int n) {
  return n * val++;
}
// ---------------------------------------------------
void analogCommand(WifiData client) {
  // Read command and react accordingly
  String command = client.readStringUntil('\r');

  val1 = analogRead(0);

  // Return temp measurement
  if (command == "val1") {
    client.println("HTTP/1.1 200 OK\n");
    client.print(val1);
    client.print(EOL);    //char terminator
  }

  if (command == "val2") {
    client.println("HTTP/1.1 200 OK\n");
    client.print(CalculVal(1));
    client.print(EOL);    //char terminator
  }
  
  if (command == "val3") {
    client.println("HTTP/1.1 200 OK\n");
    client.print(val3);
    client.print(EOL);    //char terminator
  }
}
// ---------------------------------------------------
void digitalCommand(WifiData client) {
  int pin, value;
 
  // Read pin number
  pin = client.parseInt();
 
  // If the next character is a '/' it means we have an URL
  // with a value like: "/digital/13/1"
  if (client.read() == '/') {
    value = client.parseInt();
    digitalWrite(pin, value);
  }
  else {
    value = digitalRead(pin);
  }
 
  // Send feedback to client
  client.println("Status: 200 OK\n");
  client.print(EOL);    //char terminator
}
